# coding=utf-8
#!/usr/bin/python
import matplotlib
#matplotlib.use('agg')


# This script calculates the hot emissions of gasoline passenger car
# for each arc during after-work rush hours
import csv
import numpy as np
import pylab as plt
import scipy as sy
import os
import sys
import matplotlib
import re
import matplotlib.lines as mlines
from atmopy import *
from atmopy.display import *

content = [("Species", "[input]", "StringList"),
	   ("Directory", "[input]", "String")]

config = talos.Config(sys.argv[1], content)

shape = (config.Ny, config.Nx)

#plt.ioff()

# pre-setting figures for articles

width = 25 / 2.54
#matplotlib.rcParams["figure.figsize"] = (0.9 * width, .5 * width)
matplotlib.rcParams["figure.figsize"] = (0.9 * width, width)
matplotlib.rcParams["figure.subplot.left"] = 0.08 #0.05
matplotlib.rcParams["figure.subplot.right"] = 0.75 # 0.8
matplotlib.rcParams["figure.subplot.bottom"] = 0.08
matplotlib.rcParams["figure.subplot.top"] = 0.95
font_size = 11
matplotlib.rcParams["font.size"] = font_size
matplotlib.rcParams["axes.titlesize"] = font_size + 2
matplotlib.rcParams["axes.labelsize"] = font_size +2
matplotlib.rcParams["xtick.labelsize"] = font_size
matplotlib.rcParams["ytick.labelsize"] = font_size
matplotlib.rcParams["legend.fontsize"] = font_size
matplotlib.rcParams["xtick.major.size"] = 2
matplotlib.rcParams["xtick.minor.size"] = 1
matplotlib.rcParams["ytick.major.size"] = 2
matplotlib.rcParams["ytick.minor.size"] = 1

# display the NOx emissions map of Clermont during afternoon rush hour

#input_node = open("node-trafipollu.txt")
input_node = open("node-trafipollu-eff.txt")
node = {}

for line in input_node.readlines():
    line_info = [x for x in re.split('\t| ', line) if x.strip() != '']
    # Converting from text to number.
    node[int(line_info[0])] = (float(line_info[1]), float(line_info[2]))

input_node.close()

# Input data visum
# ------------------

#plot_data_visum = np.loadtxt("emission-trafipollu.txt")
plot_data_visum = np.loadtxt("emission-trafipollu-eff.txt")
plot_arc_size_visum = np.size(plot_data_visum[:,0])
node_begin_visum = []
node_end_visum = []
emission_visum = []
arc_id_visum = []

for i in range(0,plot_arc_size_visum):
    # line_info = line.split('\t')
    node_begin_visum.append(int(plot_data_visum[i,1]))
    node_end_visum.append(int(plot_data_visum[i,2]))
#    emission_visum.append(float(plot_data_visum[i,3])) #!!!!!!!! Modif YK
    arc_id_visum.append(int(plot_data_visum[i,0]))

# Concentrations results
#directory_results = "/net/libre/yomi/kimy/StreetInGrid/Trafipollu/sing/leperreux/results_sing/street/"

species = config.Species
directory = config.Directory
#"/net/libre/yomi/kimy/StreetInGrid/Trafipollu/version_new/2403-0604/results_test/"

data = getd(config, directory + "NO2.bin")	
reshaped_no2 = np.reshape(data, (data.shape[0], data.shape[1]))
data = getd(config, directory + "NO.bin")	
reshaped_no = np.reshape(data, (data.shape[0], data.shape[1]))
data2 = reshaped_no2 + (reshaped_no * 46. / 30.) # NOx

# data = getd(config, directory + species[0] + ".bin")	
# data2 = np.reshape(data, (data.shape[0], data.shape[1]))


print data2.shape
#dd = data2[:,street_ind]

import datetime
date_begin = datetime.datetime(2014,3,24,1)
for t in range(1):
#for t in range(1):
#  if t == 1:  
    current_date = date_begin + datetime.timedelta(hours = t)
#    print current_date
    emission_visum = []
    hour = current_date.strftime("%Y%m%d_%H")
#    hour = str(t).zfill(2)
    # file_results = directory_results + hour + "-00"
    # plot_results = np.loadtxt(file_results)
    # ID, O3, NO, NO2
    for i in range(0,plot_arc_size_visum):
#        print plot_results[i]
#        emission_visum.append(float(plot_results[i,2]) + float(plot_results[i,3])) # sum NO + NO2
        t_ind = 9 * 24 # 25/03 1H
        emission_visum.append(data2[t_ind, i])
#     emission_visum.append(20.) # Same value for all streets

# Street fragments for Boulevard Alsace-Lorraine 
    AL_list = [631, 598, 685, 668, 687, 688, 689, 595, 692, 693, 826]
    conc_al = 0.0
    v_AL = []
    for li in AL_list:
        for i in range(0,plot_arc_size_visum):
            if li == arc_id_visum[i]:
#                print "id: ", li, "concentration: ", emission_visum[i] 
                v_AL.append(emission_visum[i])
                conc_al = conc_al + emission_visum[i]
                if li == 692:
                    conc_692 = emission_visum[i]
#     print min(v_AL), "\t", max(v_AL), "\t", conc_al / len(AL_list), "\t", conc_692
# #        print "Mean modelled concentration at boulevard d'Alsace-Lorraine: ", conc_al / len(AL_list)
# sys.exit()

vmax = max(emission_visum)
print "Max: ", vmax
vmax = 225 # 750 # ninterv * 20
# Display intervals

#interv = range(0,1500,100)
ninterv = 15
step = vmax / ninterv

print "step: ", step
#vmax = step * ninterv
interv = np.arange(0,vmax,step)
print interv

alpha = 1. # 0.5
beta = 1.
size = np.size(interv)
interval = []
interval_l = []
# Interval for plotting

for i in range(0,size):
    interval.append(alpha*interv[i])
    interval_l.append(alpha*interv[i]/beta)

# Set the line thickness
s = 800 # emissions
s = 800 # for concentration results


# PLOTTING
# ---------

w = 2
w_0 = 1


# Plot Visum
# ----------

fig = plt.figure()
# fig.suptitle("NOx emission map of center Clermont-Ferrand during after-work rush hour (in g/km)")
visum = plt.subplot(111)
#plt.xlabel("VISUM")

# Display the node numbers.
# ------------------------
# for inode in node:
#     visum.text(node[inode][0], node[inode][1], str(inode))


lw_max = 2
for i in range(len(node_begin_visum)):
    xy_begin = node[node_begin_visum[i]]
    xy_end = node[node_end_visum[i]]

    # if xy_begin[0] > 300.0 and xy_begin[1] >380 and xy_end[0]<400 and xy_end[1] < 520.0:

        # if emission_visum[i] == 0.0 or emission_visum[i] == 1.0:
        #     visum.plot([xy_begin[0], xy_end[0]],
        #              [xy_begin[1], xy_end[1]],'k-',lw = w_0,
        #              label='0.0')interval[0] and nox[i] < interval[1]:
    if emission_visum[i] != 1.0 and emission_visum[i] >= interval[0] and emission_visum[i] < interval[1]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'indigo',linestyle = '-',
                     lw = 0.1)
#                     lw = emission_visum[i]/s)
    elif emission_visum[i] >= interval[1] and emission_visum[i] < interval[2]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'midnightblue',linestyle = '-',
                     lw = lw_max) #emission_visum[i]/s)
    elif emission_visum[i] >= interval[2] and emission_visum[i] < interval[3]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'navy',linestyle = '-',
                     lw = lw_max) #emission_visum[i]/s)
    elif emission_visum[i] >= interval[3] and emission_visum[i] <interval[4] :
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'blue',linestyle = '-',
                     lw = lw_max) # emission_visum[i]/s)
    elif emission_visum[i] >= interval[4] and emission_visum[i] < interval[5]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'royalblue',linestyle = '-',
                     lw = lw_max) # emission_visum[i]/s)
    elif emission_visum[i] >= interval[5] and emission_visum[i] < interval[6]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'deepskyblue',linestyle = '-',
                     lw = lw_max) # emission_visum[i]/s)
    elif emission_visum[i] >= interval[6] and emission_visum[i] < interval[7]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'cyan',linestyle = '-',
                     lw = lw_max) #emission_visum[i]/s)
    elif emission_visum[i] >= interval[7] and emission_visum[i] < interval[8]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'lime',linestyle = '-',
                     lw = lw_max) #emission_visum[i]/s)
    elif emission_visum[i] >= interval[8] and emission_visum[i] < interval[9]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'yellow',linestyle = '-',
                     lw = lw_max) # emission_visum[i]/s)
    elif emission_visum[i] >= interval[9] and emission_visum[i] < interval[10]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'gold',linestyle = '-',
                     lw = lw_max) # emission_visum[i]/s)
    elif emission_visum[i] >= interval[10] and emission_visum[i] <interval[11]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'orange',linestyle = '-',
                     lw = lw_max) # emission_visum[i]/s)
    elif emission_visum[i] >= interval[11] and emission_visum[i] < interval[12]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'salmon',linestyle = '-',
                     lw = lw_max) #emission_visum[i]/s)
    elif emission_visum[i] >= interval[12] and emission_visum[i] < interval[13]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color = 'red',linestyle = '-',
                     lw = lw_max) # emission_visum[i]/s)
    elif emission_visum[i] >= interval[13] and emission_visum[i] < interval[14]:
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                 color = 'firebrick',linestyle = '-',
                     lw = lw_max) #emission_visum[i]/s)
    else :
            visum.plot([xy_begin[0], xy_end[0]],
                     [xy_begin[1], xy_end[1]],
                     color='darkred',linestyle='-',
                     lw = lw_max) #emission_visum[i]/s)
# plt.ylim(ymax = 540)
# plt.ylim(ymin = 360)
# plt.xlim(xmax = 420)
# plt.xlim(xmin = 280)

# plot legend
# -----------

intro = mlines.Line2D([],[],color = 'w',linestyle='-',lw = 0.5 )
in_0 = mlines.Line2D([],[],color = 'k',linestyle='-',lw = 0.5 )
in_1 = mlines.Line2D([],[],color = 'indigo',linestyle='-',lw = 0.8 )
in_2 = mlines.Line2D([],[],color = 'midnightblue',linestyle='-',lw = 1 )
in_3 = mlines.Line2D([],[],color = 'navy',linestyle='-',lw = 1.2 )
in_4 = mlines.Line2D([],[],color = 'blue',linestyle='-',lw = 1.4 )
in_5 = mlines.Line2D([],[],color = 'royalblue',linestyle='-',lw = 1.6 )
in_6 = mlines.Line2D([],[],color = 'deepskyblue',linestyle='-',lw = 1.8 )
in_7 = mlines.Line2D([],[],color = 'cyan',linestyle='-',lw = 2 )
in_8 = mlines.Line2D([],[],color = 'lime',linestyle='-',lw = 2.2 )
in_9 = mlines.Line2D([],[],color = 'gold',linestyle='-',lw = 2.4 )
in_10 = mlines.Line2D([],[],color = 'orange',linestyle='-',lw = 2.6 )
in_11 = mlines.Line2D([],[],color = 'salmon',linestyle='-',lw = 2.8 )
in_12 = mlines.Line2D([],[],color = 'tomato',linestyle='-',lw = 3 )
in_13 = mlines.Line2D([],[],color = 'red',linestyle='-',lw = 3.2 )
in_14 = mlines.Line2D([],[],color = 'firebrick',linestyle='-',lw = 3.4 )
in_15 = mlines.Line2D([],[],color = 'darkred',linestyle='-',lw = 3.6 )

handles = [intro, in_0, in_1, in_2, in_3, in_4, in_5, in_6, in_7, in_8, in_9, in_10, in_11, in_12, in_13, in_14, in_15]

labels = ['in $\mu$g/m$^3$','0.0', '] '+str(interval_l[0])+', '+str(interval_l[1])+' [','[ '+str(interval_l[1])+', '+str(interval_l[2])+' [','[ '+str(interval_l[2])+', '+str(interval_l[3])+' [', '[ '+str(interval_l[3])+', '+str(interval_l[4])+' [',  '[ '+str(interval_l[4])+', '+str(interval_l[5])+' [','[ '+str(interval_l[5])+', '+str(interval_l[6])+' [','[ '+str(interval_l[6])+', '+str(interval_l[7])+' [','[ '+str(interval_l[7])+', '+str(interval_l[8])+' [','[ '+str(interval_l[8])+', '+str(interval_l[9])+' [','[ '+str(interval_l[9])+', '+str(interval_l[10])+' [', '[ '+str(interval_l[10])+', '+str(interval_l[11])+' [','[ '+str(interval_l[11])+', '+str(interval_l[12])+' [','[ '+str(interval_l[12])+', '+str(interval_l[13])+' [','[ '+str(interval_l[13])+', '+str(interval_l[14])+' [','[ '+str(interval_l[14])+', ~ [' ]

# plt.legend(handles,labels,bbox_to_anchor=(1.02,0.02),loc = 'lower left')


# # p_legend = plt.subplot(131)
# intro = mlines.Line2D([],[],color = 'w',linestyle='-',lw = 0.5 )
# # interval_0 = mlines.Line2D([],[],color = 'k',linestyle='-',lw = 0.5 )
# interval_0_200 = mlines.Line2D([],[],color = 'indigo',linestyle='-',lw = 0.8 )
# interval_200_400 = mlines.Line2D([],[],color = 'midnightblue',linestyle='-',lw = 1 )
# interval_400_600 = mlines.Line2D([],[],color = 'navy',linestyle='-',lw = 1.2 )
# interval_600_800 = mlines.Line2D([],[],color = 'blue',linestyle='-',lw = 1.4 )
# interval_800_1000 = mlines.Line2D([],[],color = 'royalblue',linestyle='-',lw = 1.6 )
# interval_1000_1200 = mlines.Line2D([],[],color = 'deepskyblue',linestyle='-',lw = 1.8 )
# interval_1200_1400 = mlines.Line2D([],[],color = 'cyan',linestyle='-',lw = 2 )
# interval_1400_1600 = mlines.Line2D([],[],color = 'lime',linestyle='-',lw = 2.2 )
# interval_1600_1800 = mlines.Line2D([],[],color = 'gold',linestyle='-',lw = 2.4 )
# interval_1800_2000 = mlines.Line2D([],[],color = 'orange',linestyle='-',lw = 2.6 )
# interval_2000_2200 = mlines.Line2D([],[],color = 'salmon',linestyle='-',lw = 2.8 )
# interval_2200_2400 = mlines.Line2D([],[],color = 'tomato',linestyle='-',lw = 3 )
# interval_2400_2600 = mlines.Line2D([],[],color = 'red',linestyle='-',lw = 3.2 )
# interval_2600_2800 = mlines.Line2D([],[],color = 'firebrick',linestyle='-',lw = 3.4 )
# interval_2800_plus = mlines.Line2D([],[],color = 'darkred',linestyle='-',lw = 3.6 )

# # p_legend = plt.subplot(111)
# handles = [intro,interval_0_200,interval_200_400,interval_400_600,interval_600_800,interval_800_1000,interval_1000_1200,interval_1200_1400,interval_1400_1600,interval_1600_1800,interval_1800_2000,interval_2000_2200,interval_2200_2400,interval_2400_2600,interval_2600_2800,interval_2800_plus]

# # labels = [u'En g/km','[0.0,50)','[50,100)','[100,150)','[150,200)','[200,250)','[250,300)','[300,350)','[350,400)','[400,450)','[450,500)','[500,550)','[550,600)','[600,650)','[650,700)','[700, ~)']

# labels = [u'En g/km','[0.0,20)','[20,40)','[40,60)','[60,80)','[80,100)','[100,120)','[120,14)','[140,160)','[160,180)','[180,200)','[200,220)','[220,240)','[240,260)','[260,280)','[280, ~)']


# bbox_to_anchor(0.5,-0.1)
plt.legend(handles,labels,bbox_to_anchor=(1.05,0.0),loc = 'lower left')
# plt.subplots_adjust(right = 0.2)
plt.subplots_adjust(bottom = 0.1)

a = visum.get_yticks().tolist()
visum.set_yticklabels(a)

#plt.title("2014-03-25_08")
#plt.grid()
plt.show()
#plt.savefig("output/figure/emission_nox_center_visum_ladta.png")
